# -*- coding: utf-8 -*-
from setuphelpers import *


def update_package():
    # Declaring local variables
    if control.architecture == "x64":
        arch = control.architecture
    else:
        arch = "win32"
    bin_contains = "TortoiseSVN"
    result = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name
    url = "https://tortoisesvn.net/downloads.html"

    # Getting latest version from official sources
    print("URL used is: %s" % url)
    for bs_search in bs_find_all(url, "a", "class", "btn", timeout=10):
        if bin_contains in bs_search["href"] and arch in bs_search["href"]:
            version = bs_search["href"].split("-")[1]
            latest_bin = bs_search["href"].split("/")[-2]
            download_url = bs_search["href"]
            break
    print("URL used is: %s" % download_url)
    for bs_search2 in bs_find_all(download_url, "a", "class", "mirror_link", timeout=10):
        if bin_contains in bs_search2["href"] and arch in bs_search["href"]:
            # version = bs_search2["href"].split("-")[1]
            # latest_bin = bs_search2["href"].split("/")[-2]
            download_url2 = "https://fr.osdn.net/" + bs_search2["href"]
            break
        print("Latest %s version is: %s" % (app_name, version))
        print("Download URL is: %s" % download_url2)
    # Downloading latest binaries
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url2, latest_bin)
    else:
        print("Binary is present: %s" % latest_bin)

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        result = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.version = "%s-%s" % (Version(version), control.version.split("-", 1)[-1])
    # control.set_software_version(version)
    control.save_control_to_wapt()
    # Deleting outdated binaries
    remove_outdated_binaries(version)
    # Validating or not update-package-sources
    return result
